<template>
  <b-autocomplete
    v-model="buffer.name"
    :data="filteredDisciplines"
    icon="hubzilla"
    v-validate="'required'"
    clearable
    :open-on-focus="true"
    placeholder="Discipline HCERES *"
    field="name"
    @input="inputChanged"
    @select="selectDiscipline">
      <template slot="empty">Aucune discipline trouvée</template>
    </b-autocomplete>
</template>

<script>
export default {
  name: 'DisciplineInput',
  inject: ['$validator'],
  props: {
    value: {
      type: Object,
      default: function () {
        return {
          id: null,
          name: ''
        }
      }
    }
  },
  data () {
    return {
      buffer: Object.assign({}, this.value)
    }
  },
  computed: {
    allDisciplines: function () {
      return this.$store.getters['api/disciplines']
    },
    filteredDisciplines () {
      return this.allDisciplines.filter((option) => {
        return option.name
          .toString()
          .toLowerCase()
          .indexOf(this.buffer.name.toLowerCase()) >= 0
      })
    }
  },
  methods: {
    compare (disciplineA, disciplineB) {
      let comparison = 0
      if (disciplineA.name > disciplineB.name) {
        comparison = 1
      } else if (disciplineA.name < disciplineB.name) {
        comparison = -1
      }
      return comparison
    },
    selectDiscipline (option) {
      if (option) {
        this.buffer.id = option.id
        this.buffer.name = option.name
      }
    },
    inputChanged () {
      if (this.filteredDisciplines.length === 1 && this.filteredDisciplines[0].name === this.buffer.name) {
        this.buffer.id = this.filteredDisciplines[0].id
        this.buffer.name = this.filteredDisciplines[0].name
      } else {
        this.buffer.id = null
      }
      this.$emit('input', this.buffer)
    }
  },
  watch: {
    value: {
      handler () {
        this.buffer = Object.assign({}, this.value)
      },
      deep: true
    }
  },
  created () {
    this.$store.dispatch('api/getDisciplines')
  }
}
</script>
